## ledger 3.1.2~pre1+g3a00e1c+dfsg1

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 2.8.5)
if(POLICY CMP0042)
  # CMP0042 is only known to CMake 3.0 and above
  cmake_policy(SET CMP0042 OLD)
endif(POLICY CMP0042)

PROJECT(ledger)

set(Ledger_VERSION_MAJOR 3)
set(Ledger_VERSION_MINOR 1)
set(Ledger_VERSION_PATCH 2)
set(Ledger_VERSION_PRERELEASE "")
set(Ledger_VERSION_DATE  20160801)

set(Ledger_TEST_TIMEZONE "America/Chicago")

# Point CMake at any custom modules we may ship
list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")

enable_testing()

add_definitions(-std=c++11)
if (CYGWIN)
  add_definitions(-U__STRICT_ANSI__)
endif()

########################################################################

option(USE_PYTHON "Build support for the Python scripting bridge" OFF)
option(USE_DOXYGEN "Build reference documentation using Doxygen" OFF)

option(DISABLE_ASSERTS "Build without any internal consistency checks" OFF)
option(BUILD_DEBUG "Build support for runtime debugging" OFF)

option(BUILD_LIBRARY "Build and install Ledger as a library" ON)
option(BUILD_DOCS "Build and install documentation" OFF)
option(BUILD_WEB_DOCS "Build version of documentation suitable for viewing online" OFF)
option(BUILD_EMACSLISP "Build and install ledger-mode for Emacs" OFF)

if (BUILD_DEBUG)
  set(CMAKE_BUILD_TYPE Debug)
  set(DEBUG_MODE 1)
else()
  set(CMAKE_BUILD_TYPE Release)
  set(DEBUG_MODE 0)
endif()

if (DISABLE_ASSERTS)
  set(NO_ASSERTS 1)
else()
  set(NO_ASSERTS 0)
endif()

if (CLANG_GCOV)
  set(PROFILE_LIBS profile_rt)
  set(CMAKE_REQUIRED_LIBRARIES ${PROFILE_LIBS})
endif()

########################################################################

set(Python_ADDITIONAL_VERSIONS 2.7 2.6)
find_package(PythonInterp)      # Used for running tests

if (USE_PYTHON)
  if (NOT BUILD_LIBRARY)
    message(ERROR "Building the python module requires BUILD_LIBRARY=ON.")
  endif()

  find_package(PythonLibs)
  if (PYTHONLIBS_FOUND)
    set(BOOST_PYTHON python)
    set(HAVE_BOOST_PYTHON 1)
    include_directories(SYSTEM ${PYTHON_INCLUDE_DIRS})
  else()
    set(HAVE_BOOST_PYTHON 0)
    message("Could not find a Python library to use with Boost.Python")
  endif()
else()
  set(HAVE_BOOST_PYTHON 0)
endif()

# Set BOOST_ROOT to help CMake to find the right Boost version
find_package(Boost 1.49.0
  REQUIRED date_time filesystem system iostreams regex unit_test_framework
  ${BOOST_PYTHON})

include_directories(SYSTEM ${Boost_INCLUDE_DIRS})
link_directories(${Boost_LIBRARY_DIRS})

########################################################################

include(CheckIncludeFiles)
include(CheckLibraryExists)
include(CheckFunctionExists)
include(CheckCSourceCompiles)
include(CheckCXXSourceCompiles)
include(CheckCXXSourceRuns)
include(CMakePushCheckState)

check_function_exists(access HAVE_ACCESS)
check_function_exists(realpath HAVE_REALPATH)
check_function_exists(getpwuid HAVE_GETPWUID)
check_function_exists(getpwnam HAVE_GETPWNAM)
check_function_exists(ioctl HAVE_IOCTL)
check_function_exists(isatty HAVE_ISATTY)

check_c_source_compiles("
#include <sys/types.h>
#include <sys/wait.h>
#include <unistd.h>
#include <stdlib.h>
#include <string.h>
#include <stdio.h>

int main() {
  int status, pfd[2];
  status = pipe(pfd);
  status = fork();
  if (status < 0) {
    ;
  } else if (status == 0) {
    char *arg0 = NULL;

    status = dup2(pfd[0], STDIN_FILENO);

    close(pfd[1]);
    close(pfd[0]);

    execlp(\"\", arg0, (char *)0);
    perror(\"execl\");
    exit(1);
  } else {
    close(pfd[0]);
  }
  return 0;
}" UNIX_PIPES_COMPILES)

if (UNIX_PIPES_COMPILES)
  set(HAVE_UNIX_PIPES 1)
else()
  set(HAVE_UNIX_PIPES 0)
endif()

cmake_push_check_state()

set(CMAKE_REQUIRED_INCLUDES ${CMAKE_INCLUDE_PATH} ${Boost_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES ${Boost_LIBRARIES} icuuc ${PROFILE_LIBS})

check_cxx_source_runs("
#include <boost/regex/icu.hpp>

using namespace boost;

int main() {
  std::string text = \"Активы\";
  u32regex r = make_u32regex(\"активы\", regex::perl | regex::icase);
  return u32regex_search(text, r) ? 0 : 1;
}" BOOST_REGEX_UNICODE_RUNS)

if (BOOST_REGEX_UNICODE_RUNS)
  set(HAVE_BOOST_REGEX_UNICODE 1)
else()
  set(HAVE_BOOST_REGEX_UNICODE 0)
endif()

cmake_pop_check_state()

# Check if fix for https://github.com/boostorg/python/issues/39 is needed
if (HAVE_BOOST_PYTHON)
cmake_push_check_state()

set(CMAKE_REQUIRED_INCLUDES
    ${CMAKE_INCLUDE_PATH} ${Boost_INCLUDE_DIRS} ${PYTHON_INCLUDE_DIRS})
set(CMAKE_REQUIRED_LIBRARIES
    ${Boost_LIBRARIES} ${PYTHON_LIBRARIES} ${PROFILE_LIBS})

check_cxx_source_compiles("
#include <boost/python.hpp>

struct X { int y; };

int main()
{
  boost::python::make_setter(&X::y);
  return 0;
}" BOOST_MAKE_SETTER_COMPILES)

if (BOOST_MAKE_SETTER_COMPILES)
  set(HAVE_BOOST_159_ISSUE_39 0)
else()
  set(HAVE_BOOST_159_ISSUE_39 1)
endif()

cmake_pop_check_state()
endif()

########################################################################

include_directories(${CMAKE_INCLUDE_PATH})

macro(find_opt_library_and_header _header_var _header _lib_var _lib _have_var)
  if (${_have_var})
    find_path(${_header_var} ${_header})
    if (NOT ${_header_var})
      set(${_have_var} 0)
    else()
      find_library(${_lib_var} ${_lib})
      if (NOT ${_lib_var})
        set(${_have_var} 0)
      else()
        include_directories(SYSTEM "${${_header_var}}")
        set(${_have_var} 1)
      endif()
    endif()
  else()
    set(${_have_var} 0)
  endif()
endmacro(find_opt_library_and_header _header_var _header _lib_var _lib _have_var)

macro(find_req_library_and_header _header_var _header _lib_var _lib)
  find_path(${_header_var} ${_header})
  if (NOT ${_header_var})
    message(SEND_ERROR "Could not find ${_header} on your system")
  else()
    include_directories(SYSTEM "${${_header_var}}")
    find_library(${_lib_var} ${_lib})
    if (NOT ${_lib_var})
      message(SEND_ERROR "Could not find library ${_lib} on your system")
    endif()
  endif()
endmacro(find_req_library_and_header _header_var _header _lib_var _lib)

find_req_library_and_header(GMP_PATH gmp.h GMP_LIB gmp)
find_req_library_and_header(MPFR_PATH mpfr.h MPFR_LIB mpfr)

check_library_exists(edit readline "" HAVE_EDIT)
find_opt_library_and_header(EDIT_PATH histedit.h EDIT_LIB edit HAVE_EDIT)

#find_package(Gettext)           # Used for running tests

#if (GETTEXT_FOUND)
#  set(HAVE_GETTEXT 1)
#else()
  set(HAVE_GETTEXT 0)
#endif()

#find_path(INTL_PATH libintl.h)
#find_library(INTL_LIB intl)
#include_directories(SYSTEM "${INTL_PATH}")

########################################################################

macro(add_ledger_library_dependencies _target)
  target_link_libraries(${_target} ${MPFR_LIB})
  target_link_libraries(${_target} ${GMP_LIB})
  if (HAVE_EDIT)
    target_link_libraries(${_target} ${EDIT_LIB})
  endif()
  if (HAVE_GETTEXT)
    target_link_libraries(${_target} ${INTL_LIB})
  endif()
  if (HAVE_BOOST_PYTHON)
    if(CMAKE_SYSTEM_NAME STREQUAL Darwin)
      # Don't link directly to a Python framework on OS X, to avoid segfaults
      # when the module is imported from a different interpreter
      target_link_libraries(${_target} ${Boost_LIBRARIES})
      set_target_properties(${_target} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
    else()
      target_link_libraries(${_target} ${Boost_LIBRARIES} ${PYTHON_LIBRARIES})
    endif()
  else()
    target_link_libraries(${_target} ${Boost_LIBRARIES})
  endif()
  if (HAVE_BOOST_REGEX_UNICODE)
    target_link_libraries(${_target} icuuc)
  endif()
  target_link_libraries(${_target} ${PROFILE_LIBS})
endmacro(add_ledger_library_dependencies _target)

########################################################################

include(FindUtfcpp)
if (UTFCPP_FOUND)
  include_directories("${UTFCPP_INCLUDE_DIR}")
else()
  message(FATAL_ERROR "Missing required header file: utf8.h\n"
    "Define UTFCPP_PATH or install utfcpp locally into the source tree below lib/utfcpp/."
    )
endif()

set(CMAKE_LIBRARY_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})
set(CMAKE_RUNTIME_OUTPUT_DIRECTORY ${PROJECT_BINARY_DIR})

# add the binary tree to the search path for include files so that we will
# find system.hh
include_directories("${PROJECT_BINARY_DIR}")

configure_file(
  ${PROJECT_SOURCE_DIR}/src/system.hh.in
  ${PROJECT_BINARY_DIR}/system.hh)

if (CMAKE_CXX_COMPILER MATCHES "clang")
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
elseif(CMAKE_CXX_COMPILER MATCHES "g\\+\\+")
  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
endif()

add_subdirectory(src)
add_subdirectory(doc)
if (BUILD_EMACSLISP)
  add_subdirectory(lisp)
endif()
add_subdirectory(test)

########################################################################

# build a CPack driven installer package
include (InstallRequiredSystemLibraries)

set (CPACK_RESOURCE_FILE_LICENSE "${CMAKE_SOURCE_DIR}/LICENSE.md")
set (CPACK_PACKAGE_VERSION_MAJOR "${Ledger_VERSION_MAJOR}")
set (CPACK_PACKAGE_VERSION_MINOR "${Ledger_VERSION_MINOR}")
set (CPACK_PACKAGE_VERSION_PATCH "${Ledger_VERSION_PATCH}${Ledger_VERSION_PRERELEASE}")

set (CPACK_GENERATOR "TBZ2")
set (CPACK_SOURCE_GENERATOR "TBZ2")
set (CPACK_SOURCE_PACKAGE_FILE_NAME
  "${CMAKE_PROJECT_NAME}-${CPACK_PACKAGE_VERSION_MAJOR}.${CPACK_PACKAGE_VERSION_MINOR}.${CPACK_PACKAGE_VERSION_PATCH}")
set (CPACK_SOURCE_IGNORE_FILES "/.git*;/.dir-locals.el;~$;/doc/website/;/doc/wiki/;/lib/*.sh;/lib/Makefile;/tools/;${CPACK_SOURCE_IGNORE_FILES}")

include (CPack)

### CMakeLists.txt ends here

=== src/CMakeLists.txt ===
set(LEDGER_CLI_SOURCES
  global.cc
  main.cc)

set(LEDGER_SOURCES
  stats.cc
  generate.cc
  csv.cc
  convert.cc
  draft.cc
  emacs.cc
  org.cc
  ptree.cc
  print.cc
  output.cc
  precmd.cc
  chain.cc
  filters.cc
  report.cc
  views.cc
  select.cc
  session.cc
  option.cc
  lookup.cc
  compare.cc
  iterators.cc
  timelog.cc
  textual.cc
  temps.cc
  journal.cc
  account.cc
  xact.cc
  post.cc
  item.cc
  format.cc
  query.cc
  scope.cc
  expr.cc
  op.cc
  parser.cc
  token.cc
  value.cc
  balance.cc
  quotes.cc
  history.cc
  pool.cc
  annotate.cc
  commodity.cc
  amount.cc
  stream.cc
  mask.cc
  times.cc
  error.cc
  utils.cc
  strptime.cc
  wcwidth.cc)

if (HAVE_BOOST_PYTHON)
  list(APPEND LEDGER_SOURCES
    py_account.cc
    py_amount.cc
    py_balance.cc
    py_commodity.cc
    py_expr.cc
    py_format.cc
    py_item.cc
    py_journal.cc
    py_post.cc
    py_session.cc
    py_times.cc
    py_utils.cc
    py_value.cc
    py_xact.cc
    pyinterp.cc
    pyledger.cc)
endif()

set(LEDGER_INCLUDES
  account.h
  amount.h
  annotate.h
  balance.h
  chain.h
  commodity.h
  compare.h
  context.h
  convert.h
  csv.h
  draft.h
  emacs.h
  error.h
  expr.h
  exprbase.h
  filters.h
  flags.h
  format.h
  generate.h
  global.h
  history.h
  item.h
  iterators.h
  journal.h
  lookup.h
  mask.h
  op.h
  option.h
  org.h
  output.h
  parser.h
  pool.h
  post.h
  precmd.h
  predicate.h
  print.h
  pstream.h
  ptree.h
  pyfstream.h
  pyinterp.h
  pyutils.h
  query.h
  quotes.h
  report.h
  scope.h
  select.h
  session.h
  stats.h
  stream.h
  temps.h
  timelog.h
  times.h
  token.h
  unistring.h
  utils.h
  value.h
  views.h
  xact.h
  strptime.h
  ${PROJECT_BINARY_DIR}/system.hh)

if (CMAKE_BUILD_TYPE STREQUAL "Debug")
  if ((CMAKE_CXX_COMPILER MATCHES "clang") OR (CMAKE_CXX_COMPILER MATCHES "cxx"))
    add_definitions(
      -Weverything
      -Wno-disabled-macro-expansion
      -Wno-padded
      -Wno-weak-vtables
      -Wno-exit-time-destructors
      -Wno-global-constructors
      -Wno-switch-enum
      -Wno-missing-prototypes
      -Wno-missing-noreturn
      -Wno-unused-parameter
      -Wno-c++98-compat
      -fno-limit-debug-info)

    macro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
      set(_pch_filename "${_header_filename}.pch")

      set_source_files_properties(
        ${${_src_list}} PROPERTIES COMPILE_FLAGS "-include ${_header_filename}")
      if (_other_srcs)
        set_source_files_properties(
          ${_other_srcs} PROPERTIES COMPILE_FLAGS "-include ${_header_filename}")
      endif()
      list(APPEND ${_src_list} ${_pch_filename})

      set(_args ${CMAKE_CXX_FLAGS})
      list(APPEND _args ${CMAKE_CXX_FLAGS_DEBUG})
      if (BUILD_LIBRARY)
        list(APPEND _args ${CMAKE_SHARED_LIBRARY_CXX_FLAGS})
      endif()
      list(APPEND _args "-std=c++11 ")
      if (CYGWIN)
        list(APPEND _args "-U__STRICT_ANSI__")
      endif()
      list(APPEND _args "-x c++-header " ${_inc})
      list(APPEND _args -c ${_header_filename} -o ${_pch_filename})

      get_directory_property(DIRINC INCLUDE_DIRECTORIES)
      foreach(_inc ${DIRINC})
        list(APPEND _args "-isystem " ${_inc})
      endforeach(_inc ${DIRINC})

      separate_arguments(_args)

      add_custom_command(OUTPUT ${_pch_filename}
        COMMAND rm -f ${_pch_filename}
        COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} ${_args}
        DEPENDS ${_header_filename})
    endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)

  elseif(CMAKE_CXX_COMPILER MATCHES "g\\+\\+")
    set(GXX_WARNING_FLAGS
      -pedantic
      -Wall
      -Winvalid-pch
      -Wextra
      -Wcast-align
      -Wcast-qual
      -Wfloat-equal
      -Wmissing-field-initializers
      -Wno-endif-labels
      -Wno-overloaded-virtual
      -Wsign-compare
      -Wsign-promo
      -Wwrite-strings
      -Wno-unused-parameter
      -Wno-old-style-cast
      -Wno-deprecated
      -Wno-strict-aliasing)

    add_definitions(${GXX_WARNING_FLAGS})

    macro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
      set(_gch_filename "${_header_filename}.gch")

      set_source_files_properties(
        ${${_src_list}} PROPERTIES COMPILE_FLAGS "-Winvalid-pch")
      if (_other_srcs)
        set_source_files_properties(
          ${_other_srcs} PROPERTIES COMPILE_FLAGS "-Winvalid-pch")
      endif()
      list(APPEND ${_src_list} ${_gch_filename})

      set(_args ${CMAKE_CXX_FLAGS})
      list(APPEND _args ${CMAKE_CXX_FLAGS_DEBUG})
      if (BUILD_LIBRARY)
        list(APPEND _args ${CMAKE_SHARED_LIBRARY_CXX_FLAGS})
      endif()
      list(APPEND _args ${GXX_WARNING_FLAGS})
      list(APPEND _args "-std=c++11 ")
      if (CYGWIN)
        list(APPEND _args "-U__STRICT_ANSI__")
      endif()
      list(APPEND _args "-x c++-header " ${_inc})
      list(APPEND _args -c ${_header_filename} -o ${_gch_filename})

      get_directory_property(DIRINC INCLUDE_DIRECTORIES)
      foreach(_inc ${DIRINC})
        list(APPEND _args "-isystem " ${_inc})
      endforeach(_inc ${DIRINC})

      separate_arguments(_args)

      add_custom_command(OUTPUT ${_gch_filename}
        COMMAND rm -f ${_gch_filename}
        COMMAND ${CMAKE_CXX_COMPILER} ${CMAKE_CXX_COMPILER_ARG1} ${_args}
        DEPENDS ${_header_filename})
    endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)

  else()
    macro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
    endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
  endif()
else()
  macro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
  endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
endif()

add_pch_rule(${PROJECT_BINARY_DIR}/system.hh LEDGER_SOURCES LEDGER_CLI_SOURCES)

include(GNUInstallDirs)

if (BUILD_LIBRARY)
  set(CMAKE_INSTALL_RPATH "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}")
  add_library(libledger SHARED ${LEDGER_SOURCES})
  add_ledger_library_dependencies(libledger)
  set_target_properties(libledger PROPERTIES
    PREFIX ""
    INSTALL_NAME_DIR "${CMAKE_INSTALL_PREFIX}/${CMAKE_INSTALL_LIBDIR}"
    VERSION ${Ledger_VERSION_MAJOR}
    SOVERSION ${Ledger_VERSION_MAJOR})

  add_executable(ledger main.cc global.cc)
  target_link_libraries(ledger libledger)
  if (CMAKE_SYSTEM_NAME STREQUAL Darwin AND HAVE_BOOST_PYTHON)
    target_link_libraries(ledger ${PYTHON_LIBRARIES})
  endif()

  install(TARGETS libledger DESTINATION ${CMAKE_INSTALL_LIBDIR})
  install(FILES ${LEDGER_INCLUDES}
    DESTINATION ${CMAKE_INSTALL_INCLUDEDIR}/ledger)
else()
  add_executable(ledger ${LEDGER_SOURCES} main.cc global.cc)
  add_ledger_library_dependencies(ledger)
endif()

if (USE_PYTHON)
  execute_process(COMMAND ${PYTHON_EXECUTABLE} -c
    "from __future__ import print_function
import distutils.sysconfig as s
print(s.get_python_lib(True, prefix=''))"
    OUTPUT_VARIABLE _TMP_PYTHON_SITE_PACKAGES OUTPUT_STRIP_TRAILING_WHITESPACE)
  set(PYTHON_SITE_PACKAGES ${_TMP_PYTHON_SITE_PACKAGES}
    CACHE PATH "python module directory (${_TMP_PYTHON_SITE_PACKAGES})")

  if (PYTHON_SITE_PACKAGES)
    if (WIN32 AND NOT CYGWIN)
      set(_ledger_python_module_name "ledger.pyd")
    elseif(CMAKE_SYSTEM_NAME STREQUAL Darwin)
      set(_ledger_python_module_name "ledger.so")
    else()
      set(_ledger_python_module_name "ledger${CMAKE_SHARED_LIBRARY_SUFFIX}")
    endif()

    # FIXME: symlink would be sufficient:
    # maybe using install(CODE "...") and
    # execute_process(COMMAND "${CMAKE_COMMAND}" -E create_symlink ...).
    # Windows will need a special case due to not supporting symlinks.
    add_custom_command(
      TARGET libledger POST_BUILD
      COMMAND ${CMAKE_COMMAND} -E copy_if_different
      $<TARGET_FILE:libledger> "${CMAKE_BINARY_DIR}/${_ledger_python_module_name}")
    install(
      FILES "${CMAKE_BINARY_DIR}/${_ledger_python_module_name}"
      DESTINATION ${PYTHON_SITE_PACKAGES})
  else()
    message(WARNING "PYTHON_SITE_PACKAGES not set. Will not install python module.")
  endif()
endif()

install(TARGETS ledger DESTINATION ${CMAKE_INSTALL_BINDIR})

### CMakeLists.txt ends here

=== test/CMakeLists.txt ===
include(ProcessorCount)
ProcessorCount(PROCESSORS)

if (NOT PROCESSORS EQUAL 0)
  math(EXPR JOBS "${PROCESSORS} * 2")
  set(CTEST_BUILD_FLAGS -j${JOBS})
endif()

add_custom_target(check COMMAND ${CMAKE_CTEST_COMMAND} ${CTEST_BUILD_FLAGS})

add_subdirectory(unit)

if (HAVE_BOOST_PYTHON)
  set(TEST_PYTHON_FLAGS "--python")
endif()

macro(add_ledger_harness_tests _class)
  if (PYTHONINTERP_FOUND)
    file(GLOB ${_class}_TESTS *.test)
    foreach(TestFile ${${_class}_TESTS})
      get_filename_component(TestFile_Name ${TestFile} NAME_WE)
      string(FIND ${TestFile_Name} "_py" TestFile_IsPythonTest)
      if ((TestFile_IsPythonTest EQUAL -1) OR HAVE_BOOST_PYTHON)
        add_test(NAME ${_class}Test_${TestFile_Name}
          COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/RegressTests.py
          $<TARGET_FILE:ledger> ${PROJECT_SOURCE_DIR}
          ${TestFile} ${TEST_PYTHON_FLAGS})
        set_tests_properties(${_class}Test_${TestFile_Name}
          PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
        set_target_properties(check 
          PROPERTIES DEPENDS ${_class}Test_${TestFile_Name})
      endif()
    endforeach()
  endif()
endmacro(add_ledger_harness_tests _class)

add_subdirectory(manual)
add_subdirectory(baseline)
add_subdirectory(regress)

if (PYTHONINTERP_FOUND)
  set(_class DocTests)
  file(GLOB ${_class}_TESTS ${PROJECT_SOURCE_DIR}/doc/*.texi)
  foreach(TestFile ${${_class}_TESTS})
    get_filename_component(TestFile_Name ${TestFile} NAME_WE)
    add_test(NAME ${_class}Test_${TestFile_Name}
      COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/${_class}.py
      --ledger $<TARGET_FILE:ledger> --file ${TestFile})
    set_tests_properties(${_class}Test_${TestFile_Name}
      PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
    set_target_properties(check
      PROPERTIES DEPENDS ${_class}Test_${TestFile_Name})
  endforeach()

  # CheckManpage and CheckTexinfo are disabled, since they do not work
  # reliably yet, instead they are being run as a Travis CI report.
  list(APPEND CheckOptions CheckBaselineTests) #CheckManpage CheckTexinfo
  foreach(_class ${CheckOptions})
    add_test(NAME ${_class}
      COMMAND ${PYTHON_EXECUTABLE} ${PROJECT_SOURCE_DIR}/test/${_class}.py
      --ledger $<TARGET_FILE:ledger> --source ${PROJECT_SOURCE_DIR})
    set_tests_properties(${_class}
      PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
  endforeach()
endif()

### CMakeLists.txt ends here

=== test/unit/CMakeLists.txt ===
macro(add_ledger_test _name)
  target_link_libraries(${_name} libledger)
  add_test(Ledger${_name} ${PROJECT_BINARY_DIR}/${_name})
  set_tests_properties(Ledger${_name}
    PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
endmacro(add_ledger_test _name)

include_directories(${PROJECT_SOURCE_DIR}/src)

if (BUILD_LIBRARY)
  add_executable(UtilTests t_times.cc)
  if (CMAKE_SYSTEM_NAME STREQUAL Darwin AND HAVE_BOOST_PYTHON)
    target_link_libraries(UtilTests ${PYTHON_LIBRARIES})
  endif()
  add_ledger_test(UtilTests)

  add_executable(MathTests t_amount.cc t_commodity.cc t_balance.cc t_expr.cc t_value.cc)
  set_source_files_properties(t_amount.cc t_value.cc PROPERTIES COMPILE_FLAGS "-Wno-unused-comparison")
  if (CMAKE_SYSTEM_NAME STREQUAL Darwin AND HAVE_BOOST_PYTHON)
    target_link_libraries(MathTests ${PYTHON_LIBRARIES})
  endif()
  add_ledger_test(MathTests)

  set_target_properties(check PROPERTIES DEPENDS LedgerUtilTests)
  set_target_properties(check PROPERTIES DEPENDS LedgerMathTests)
endif()

=== debian/changelog ===
ledger (3.1.2~pre1+g3a00e1c+dfsg1-5build5) bionic; urgency=medium

  * No-change rebuild for mpfr soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 24 Jan 2018 21:23:46 +0000

ledger (3.1.2~pre1+g3a00e1c+dfsg1-5build4) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 13:55:29 +0000

ledger (3.1.2~pre1+g3a00e1c+dfsg1-5build3) bionic; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 07 Nov 2017 08:30:31 +0000

ledger (3.1.2~pre1+g3a00e1c+dfsg1-5build2) bionic; urgency=medium

  * No-change rebuild for boost soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 26 Oct 2017 17:18:20 +0000

ledger (3.1.2~pre1+g3a00e1c+dfsg1-5build1) bionic; urgency=medium

  * No-change rebuild for libicu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 25 Oct 2017 15:27:45 +0000

ledger (3.1.2~pre1+g3a00e1c+dfsg1-5) unstable; urgency=medium

  * fix mangled patch exports (patching out deleted files)

 -- David Bremner <bremner@debian.org>  Mon, 07 Aug 2017 09:21:56 -0400

ledger (3.1.2~pre1+g3a00e1c+dfsg1-4) unstable; urgency=medium

  * Add maintscripts to remove obsolete startup files. Bug fix: "emacs
    startup provided in wrong package", thanks to bdale@gag.com (Bdale
    Garbee); (Closes: #857585)

 -- David Bremner <bremner@debian.org>  Sat, 05 Aug 2017 09:13:07 -0400

ledger (3.1.2~pre1+g3a00e1c+dfsg1-3) unstable; urgency=medium

  * Bug fix: "ledger deb package should suggest ledger-el", thanks to
	  Thierry (Closes: #843112).
  * Swap uploader and maintainer to better direct bug reports

 -- David Bremner <bremner@debian.org>  Wed, 19 Jul 2017 14:54:13 -0300

ledger (3.1.2~pre1+g3a00e1c+dfsg1-2) unstable; urgency=medium

  * convert ledger-el to elpa-ledger (using dh-elpa).  Bug fix: "Fails to
	  install if emacs23 is still installed", thanks to Tollef Fog Heen
	  (Closes: #839682).

 -- David Bremner <bremner@debian.org>  Wed, 05 Oct 2016 22:40:14 -0300

ledger (3.1.2~pre1+g3a00e1c+dfsg1-1) unstable; urgency=medium

  * New upstream release snapshot
  * Cherry-pick upstream pull request 465. Bug fix: "FTBFS on buildds
	  after gcc6/icu57/boost1.61", thanks to Mattia Rizzolo (Closes:
	  #833753).

 -- David Bremner <bremner@debian.org>  Tue, 13 Sep 2016 11:55:15 -0300

=== debian/control ===
Source: ledger
Section: utils
Priority: optional
Maintainer: David Bremner <bremner@debian.org>
Uploaders: Matt Palmer <mpalmer@debian.org>
Build-Depends: debhelper (>= 8), cmake, libgmp3-dev, libpcre3-dev,
	libexpat1-dev, libofx-dev, libmpfr-dev, libboost-regex-dev,
	libboost-date-time-dev, libboost-filesystem-dev,
	libboost-iostreams-dev, libboost-serialization-dev,
	libboost-test-dev, man2html-base, python, texinfo, texlive,
	libutfcpp-dev, libboost-python-dev, dh-python,
	dh-strip-nondeterminism, dh-elpa
Standards-Version: 3.9.6
Homepage: http://ledger-cli.org
Vcs-Git: git://anonscm.debian.org/git/collab-maint/ledger.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ledger.git;a=summary

Package: ledger
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: elpa-ledger, python-ledger
Description: command-line double-entry accounting program
 Ledger is a powerful and flexible double-entry accounting system run
 entirely from the command line.  Your accounts ledger is stored in one or
 more plain-text files with a very simple and readable format, and ledger
 does the hard work of balancing your books and reporting.

Package: elpa-ledger
Architecture: all
Depends: ${misc:Depends}, ${elpa:Depends}
Conflicts: emacsen-common (<< 2.0.0)
Breaks: ledger (<< 3.0.0~20140226+bedae81+dfsg1-2)
Replaces: ledger (<< 3.0.0~20140226+bedae81+dfsg1-2)
Suggests: ledger
Enhances: ledger
Description: command-line double-entry accounting program (emacs interface)
 Ledger is a powerful and flexible double-entry accounting system run
 entirely from the command line.  Your accounts ledger is stored in one or
 more plain-text files with a very simple and readable format, and ledger
 does the hard work of balancing your books and reporting.
 .
 This package provides the emacs interface.

Package: ledger-el
Architecture: all
Priority: extra
Section: oldlibs
Depends: ${misc:Depends}, elpa-ledger
Description: command-line double-entry accounting program (emacs interface)
 .
 This is a transitional package, and can safely be removed.


Package: python-ledger
Architecture: any
Section: python
Depends: ${misc:Depends}, ${python:Depends}, ${shlibs:Depends}
Description: command-line double-entry accounting program (python extension)
 Ledger is a powerful and flexible double-entry accounting system run
 entirely from the command line.  Your accounts ledger is stored in one or
 more plain-text files with a very simple and readable format, and ledger
 does the hard work of balancing your books and reporting.
 .
 This package provides the python module

Package: ledger-dbg
Architecture: any
Section: debug
Priority: extra
Depends:
    ledger (= ${binary:Version}),
    ${misc:Depends}
Description: command-line double-entry accounting program (debug symbols)
 Ledger is a powerful and flexible double-entry accounting system run
 entirely from the command line.  Your accounts ledger is stored in one or
 more plain-text files with a very simple and readable format, and ledger
 does the hard work of balancing your books and reporting.
 .
 This package contains the debugging symbols for ledger.

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-
# Sample debian/rules that uses debhelper.
# This file was originally written by Joey Hess and Craig Small.
# As a special exception, when this file is copied by dh-make into a
# dh-make output file, you may use that output file without restriction.
# This special exception was added by Craig Small in version 0.37 of dh-make.

# Uncomment this to turn on verbose mode.
#export DH_VERBOSE=1
UPSTREAM=$(shell dpkg-parsechangelog |  sed -n 's/^Version: \(.*\)-[^-]*/\1/p')

# hardening flags (CPPFLAGS kludge is for CMake)
export CPPFLAGS:=$(shell dpkg-buildflags --get CPPFLAGS)
export CFLAGS:=$(shell dpkg-buildflags --get CFLAGS) $(CPPFLAGS)
export CXXFLAGS:=$(shell dpkg-buildflags --get CXXFLAGS) $(CPPFLAGS)
export LDFLAGS:=$(shell dpkg-buildflags --get LDFLAGS)

# avoid linking ledger binary to extra libs.
LDFLAGS += -Wl,--as-needed

# These are used for cross-compiling and for saving the configure script
# from having to guess our platform (since we know it already)
DEB_HOST_GNU_TYPE   ?= $(shell dpkg-architecture -qDEB_HOST_GNU_TYPE)
DEB_BUILD_GNU_TYPE  ?= $(shell dpkg-architecture -qDEB_BUILD_GNU_TYPE)
ifneq ($(DEB_HOST_GNU_TYPE),$(DEB_BUILD_GNU_TYPE))
CROSS= --build $(DEB_BUILD_GNU_TYPE) --host $(DEB_HOST_GNU_TYPE)
else
CROSS= --build $(DEB_BUILD_GNU_TYPE)
endif

BUILDDIR=obj-$(DEB_BUILD_GNU_TYPE)

config-stamp:
	mkdir -p $(BUILDDIR)
	cd $(BUILDDIR) && \
	    cmake .. -DCMAKE_INSTALL_PREFIX=/usr -DCMAKE_VERBOSE_MAKEFILE=ON \
		-DBUILD_DOCS=1 -DBUILD_WEB_DOCS=1 -DUSE_PYTHON=ON
	touch $@

build: build-indep build-arch
binary: binary-indep binary-arch
install: install-indep install-arch

build-indep:
# We have nothing to do by default.

build-arch: build-arch-stamp

build-arch-stamp:  config-stamp
	dh_testdir

	# Add here commands to compile the package.
	$(MAKE) -C $(BUILDDIR) all doc

	touch $@

clean: 
	dh_testdir
	dh_testroot

	# Add here commands to clean up after the build process.
	dh_auto_clean

	dh_clean 

install-arch: build-arch
	dh_testdir -a
	dh_testroot -a
	dh_prep -a
	dh_installdirs -a

	$(MAKE) -C$(BUILDDIR) DESTDIR=$(CURDIR)/debian/tmp install
	dh_install -a

# Build architecture-independent files here.
binary-indep: build-indep
	dh_testroot -i
	dh_prep -i
	dh_installdirs -i
	dh_install -i
	dh_elpa
	dh_installdocs -i
	dh_installchangelogs -i
	dh_installexamples -i
	dh_installman -i
	dh_installemacsen -i
	dh_strip_nondeterminism -i
	dh_compress -i
	dh_fixperms -i
	dh_installdeb -i
	dh_gencontrol -i
	dh_md5sums -i
	dh_builddeb -i


# Build architecture-dependent files here.
binary-arch: build-arch install-arch
	dh_testdir -a
	dh_testroot -a
	dh_installchangelogs -a
	dh_installdocs -a
	dh_installexamples -a
	dh_python2 -a
	dh_installinfo $(BUILDDIR)/doc/ledger3.info*
	dh_installman -a
	dh_strip --dbg-package=ledger-dbg
	dh_strip_nondeterminism -a
	dh_compress -a -X.pdf
	dh_fixperms -a
	dh_installdeb -a
	dh_shlibdeps -a -l$(CURDIR)/debian/ledger/usr/lib/ledger
	dh_gencontrol -a
	dh_md5sums -a
	dh_builddeb -a

get-orig-source: 
	bash debian/get-orig-source.sh ${UPSTREAM} upstream/${UPSTREAM}

dch-snapshot:
	dch -v "${UPSTREAM_VERSION}-1" "Updated git snapshot for experimental."

.PHONY: build clean binary-indep binary-arch binary install get-orig-source

## ledger 3.1.2+dfsg1

=== CMakeLists.txt ===
--- 
+++ 
@@ -10,7 +10,7 @@
 set(Ledger_VERSION_MINOR 1)
 set(Ledger_VERSION_PATCH 2)
 set(Ledger_VERSION_PRERELEASE "")
-set(Ledger_VERSION_DATE  20160801)
+set(Ledger_VERSION_DATE  20190205)
 
 set(Ledger_TEST_TIMEZONE "America/Chicago")
 
@@ -27,15 +27,16 @@
 ########################################################################
 
 option(USE_PYTHON "Build support for the Python scripting bridge" OFF)
+OPTION(USE_PYTHON27_COMPONENT "Use python27 as name of Boost.Python component" OFF)
 option(USE_DOXYGEN "Build reference documentation using Doxygen" OFF)
 
 option(DISABLE_ASSERTS "Build without any internal consistency checks" OFF)
 option(BUILD_DEBUG "Build support for runtime debugging" OFF)
+option(PRECOMPILE_SYSTEM_HH "Precompile system.hh" ON)
 
 option(BUILD_LIBRARY "Build and install Ledger as a library" ON)
 option(BUILD_DOCS "Build and install documentation" OFF)
 option(BUILD_WEB_DOCS "Build version of documentation suitable for viewing online" OFF)
-option(BUILD_EMACSLISP "Build and install ledger-mode for Emacs" OFF)
 
 if (BUILD_DEBUG)
   set(CMAKE_BUILD_TYPE Debug)
@@ -68,7 +69,11 @@
 
   find_package(PythonLibs)
   if (PYTHONLIBS_FOUND)
-    set(BOOST_PYTHON python)
+    if(USE_PYTHON27_COMPONENT)
+      set(BOOST_PYTHON "python27")
+    else()
+      set(BOOST_PYTHON "python")
+    endif()
     set(HAVE_BOOST_PYTHON 1)
     include_directories(SYSTEM ${PYTHON_INCLUDE_DIRS})
   else()
@@ -97,8 +102,6 @@
 include(CheckCXXSourceRuns)
 include(CMakePushCheckState)
 
-check_function_exists(access HAVE_ACCESS)
-check_function_exists(realpath HAVE_REALPATH)
 check_function_exists(getpwuid HAVE_GETPWUID)
 check_function_exists(getpwnam HAVE_GETPWNAM)
 check_function_exists(ioctl HAVE_IOCTL)
@@ -261,7 +264,7 @@
   endif()
   if (HAVE_BOOST_PYTHON)
     if(CMAKE_SYSTEM_NAME STREQUAL Darwin)
-      # Don't link directly to a Python framework on OS X, to avoid segfaults
+      # Don't link directly to a Python framework on macOS, to avoid segfaults
       # when the module is imported from a different interpreter
       target_link_libraries(${_target} ${Boost_LIBRARIES})
       set_target_properties(${_target} PROPERTIES LINK_FLAGS "-undefined dynamic_lookup")
@@ -299,17 +302,12 @@
   ${PROJECT_SOURCE_DIR}/src/system.hh.in
   ${PROJECT_BINARY_DIR}/system.hh)
 
-if (CMAKE_CXX_COMPILER MATCHES "clang")
-  set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
-elseif(CMAKE_CXX_COMPILER MATCHES "g\\+\\+")
+if(CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
   set(CMAKE_INCLUDE_SYSTEM_FLAG_CXX "-isystem ")
 endif()
 
 add_subdirectory(src)
 add_subdirectory(doc)
-if (BUILD_EMACSLISP)
-  add_subdirectory(lisp)
-endif()
 add_subdirectory(test)
 
 ########################################################################

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -52,7 +52,6 @@
   times.cc
   error.cc
   utils.cc
-  strptime.cc
   wcwidth.cc)
 
 if (HAVE_BOOST_PYTHON)
@@ -134,24 +133,35 @@
   value.h
   views.h
   xact.h
-  strptime.h
   ${PROJECT_BINARY_DIR}/system.hh)
 
+# Windows provides no strptime(), so supply our own.
+if (WIN32 OR CYGWIN)
+  list(APPEND LEDGER_INCLUDES
+    strptime.h)
+  list(APPEND LEDGER_SOURCES
+    strptime.cc)
+endif()
+
 if (CMAKE_BUILD_TYPE STREQUAL "Debug")
-  if ((CMAKE_CXX_COMPILER MATCHES "clang") OR (CMAKE_CXX_COMPILER MATCHES "cxx"))
+  if (CMAKE_CXX_COMPILER_ID STREQUAL "Clang")
     add_definitions(
-      -Weverything
-      -Wno-disabled-macro-expansion
-      -Wno-padded
-      -Wno-weak-vtables
-      -Wno-exit-time-destructors
-      -Wno-global-constructors
-      -Wno-switch-enum
-      -Wno-missing-prototypes
-      -Wno-missing-noreturn
-      -Wno-unused-parameter
-      -Wno-c++98-compat
-      -fno-limit-debug-info)
+      # -Weverything
+      # -Wno-disabled-macro-expansion
+      # -Wno-padded
+      # -Wno-weak-vtables
+      # -Wno-exit-time-destructors
+      # -Wno-global-constructors
+      # -Wno-switch-enum
+      # -Wno-missing-prototypes
+      # -Wno-missing-noreturn
+      # -Wno-unused-parameter
+      # -Wno-c++98-compat
+      # -fno-limit-debug-info
+      -Wno-\#pragma-messages
+      -Wno-unused-local-typedef
+      --system-header-prefix=include/boost/
+      --system-header-prefix=boost/)
 
     macro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
       set(_pch_filename "${_header_filename}.pch")
@@ -189,7 +199,7 @@
         DEPENDS ${_header_filename})
     endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
 
-  elseif(CMAKE_CXX_COMPILER MATCHES "g\\+\\+")
+  elseif (CMAKE_CXX_COMPILER_ID STREQUAL "GNU")
     set(GXX_WARNING_FLAGS
       -pedantic
       -Wall
@@ -237,7 +247,7 @@
 
       get_directory_property(DIRINC INCLUDE_DIRECTORIES)
       foreach(_inc ${DIRINC})
-        list(APPEND _args "-isystem " ${_inc})
+        list(APPEND _args "-I" ${_inc})
       endforeach(_inc ${DIRINC})
 
       separate_arguments(_args)
@@ -257,7 +267,9 @@
   endmacro(ADD_PCH_RULE _header_filename _src_list _other_srcs)
 endif()
 
-add_pch_rule(${PROJECT_BINARY_DIR}/system.hh LEDGER_SOURCES LEDGER_CLI_SOURCES)
+if(PRECOMPILE_SYSTEM_HH)
+  add_pch_rule(${PROJECT_BINARY_DIR}/system.hh LEDGER_SOURCES LEDGER_CLI_SOURCES)
+endif()
 
 include(GNUInstallDirs)

=== test/unit/CMakeLists.txt ===
--- 
+++ 
@@ -20,7 +20,4 @@
     target_link_libraries(MathTests ${PYTHON_LIBRARIES})
   endif()
   add_ledger_test(MathTests)
-
-  set_target_properties(check PROPERTIES DEPENDS LedgerUtilTests)
-  set_target_properties(check PROPERTIES DEPENDS LedgerMathTests)
 endif()

=== debian/changelog ===
ledger (3.1.2+dfsg1-1) unstable; urgency=medium

  [ David Bremner ]
  * Update Vcs-Git and Vcs-Browser for the move to salsa
  * New upstream release.
  * Bug fix: "CVE-2017-2808: Ledger CLI Account Directive Use-After-Free
    Vulnerability", thanks to Salvatore Bonaccorso (Closes: #876659).
  * Bug fix: "CVE-2017-2807: Ledger CLI Tags Parsing Code Execution
    Vulnerability", thanks to Salvatore Bonaccorso (Closes: #876660).
  * Bug fix: "CVE-2017-12481 CVE-2017-12482", thanks to Moritz Muehlenhoff
    (Closes: #870900).
  * Bug fix: "Upgrade to latest upstream git", thanks to Sampo Sorsa
    (Closes: #913660).
  * Bug fix: "[Mayhem] Bug report on ledger: ledger crashes with exit
    status 139", thanks to Alexandre Rebert (Closes: #716086).
  * Give up on Gnucash support (Closes: #740757).
  * Bug fix: "Payee names containing angle brackets (&quot;&lt;&gt;&quot;)
    result in corrupti reports", thanks to Anonymous (Closes: #684603).
  * Bug fix: "short option -f (for --file) missing in manpage", thanks to
    Jonas Meurer (Closes: #839634).
  * Drop binary packages elpa-ledger-mode and ledger-el, moving to new
    source package ledger-mode.

  [ Ondřej Nový ]
  * d/control: Deprecating priority extra as per policy 4.0.1
  * d/rules: Remove trailing whitespaces

 -- David Bremner <bremner@debian.org>  Wed, 06 Feb 2019 06:48:57 -0400

=== debian/control ===
--- 
+++ 
@@ -12,8 +12,8 @@
 	dh-strip-nondeterminism, dh-elpa
 Standards-Version: 3.9.6
 Homepage: http://ledger-cli.org
-Vcs-Git: git://anonscm.debian.org/git/collab-maint/ledger.git
-Vcs-Browser: http://anonscm.debian.org/gitweb/?p=collab-maint/ledger.git;a=summary
+Vcs-Git: https://salsa.debian.org/debian/ledger.git
+Vcs-Browser: https://salsa.debian.org/debian/ledger
 
 Package: ledger
 Architecture: any
@@ -24,32 +24,6 @@
  entirely from the command line.  Your accounts ledger is stored in one or
  more plain-text files with a very simple and readable format, and ledger
  does the hard work of balancing your books and reporting.
-
-Package: elpa-ledger
-Architecture: all
-Depends: ${misc:Depends}, ${elpa:Depends}
-Conflicts: emacsen-common (<< 2.0.0)
-Breaks: ledger (<< 3.0.0~20140226+bedae81+dfsg1-2)
-Replaces: ledger (<< 3.0.0~20140226+bedae81+dfsg1-2)
-Suggests: ledger
-Enhances: ledger
-Description: command-line double-entry accounting program (emacs interface)
- Ledger is a powerful and flexible double-entry accounting system run
- entirely from the command line.  Your accounts ledger is stored in one or
- more plain-text files with a very simple and readable format, and ledger
- does the hard work of balancing your books and reporting.
- .
- This package provides the emacs interface.
-
-Package: ledger-el
-Architecture: all
-Priority: extra
-Section: oldlibs
-Depends: ${misc:Depends}, elpa-ledger
-Description: command-line double-entry accounting program (emacs interface)
- .
- This is a transitional package, and can safely be removed.
-
 
 Package: python-ledger
 Architecture: any
@@ -66,7 +40,6 @@
 Package: ledger-dbg
 Architecture: any
 Section: debug
-Priority: extra
 Depends:
     ledger (= ${binary:Version}),
     ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -55,14 +55,14 @@
 
 	touch $@
 
-clean: 
+clean:
 	dh_testdir
 	dh_testroot
 
 	# Add here commands to clean up after the build process.
 	dh_auto_clean
 
-	dh_clean 
+	dh_clean
 
 install-arch: build-arch
 	dh_testdir -a
@@ -114,7 +114,7 @@
 	dh_md5sums -a
 	dh_builddeb -a
 
-get-orig-source: 
+get-orig-source:
 	bash debian/get-orig-source.sh ${UPSTREAM} upstream/${UPSTREAM}
 
 dch-snapshot:

## ledger 3.1.3

=== CMakeLists.txt ===
--- 
+++ 
@@ -8,9 +8,9 @@
 
 set(Ledger_VERSION_MAJOR 3)
 set(Ledger_VERSION_MINOR 1)
-set(Ledger_VERSION_PATCH 2)
+set(Ledger_VERSION_PATCH 3)
 set(Ledger_VERSION_PRERELEASE "")
-set(Ledger_VERSION_DATE  20190205)
+set(Ledger_VERSION_DATE  20190331)
 
 set(Ledger_TEST_TIMEZONE "America/Chicago")

=== src/CMakeLists.txt ===
--- 
+++ 
@@ -9,7 +9,6 @@
   convert.cc
   draft.cc
   emacs.cc
-  org.cc
   ptree.cc
   print.cc
   output.cc
@@ -103,7 +102,6 @@
   mask.h
   op.h
   option.h
-  org.h
   output.h
   parser.h
   pool.h

=== test/CMakeLists.txt ===
--- 
+++ 
@@ -27,8 +27,6 @@
           ${TestFile} ${TEST_PYTHON_FLAGS})
         set_tests_properties(${_class}Test_${TestFile_Name}
           PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
-        set_target_properties(check 
-          PROPERTIES DEPENDS ${_class}Test_${TestFile_Name})
       endif()
     endforeach()
   endif()
@@ -48,8 +46,6 @@
       --ledger $<TARGET_FILE:ledger> --file ${TestFile})
     set_tests_properties(${_class}Test_${TestFile_Name}
       PROPERTIES ENVIRONMENT "TZ=${Ledger_TEST_TIMEZONE}")
-    set_target_properties(check
-      PROPERTIES DEPENDS ${_class}Test_${TestFile_Name})
   endforeach()
 
   # CheckManpage and CheckTexinfo are disabled, since they do not work

=== lib/utfcpp/v2_0/samples/Makefile ===
CC = g++
CFLAGS = -g -Wall -pedantic

docsample: docsample.cpp ../source/utf8.h
	$(CC) $(CFLAGS) docsample.cpp -odocsample

=== debian/changelog ===
ledger (3.1.3-1ubuntu7) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 05 Mar 2020 08:51:48 +0100

ledger (3.1.3-1ubuntu6) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 03 Mar 2020 21:21:28 +0100

ledger (3.1.3-1ubuntu5) focal; urgency=medium

  * Use boost1.67 to complete icu transition.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Tue, 18 Feb 2020 17:22:27 +0000

ledger (3.1.3-1ubuntu4) focal; urgency=medium

  * No-change rebuild for icu soname change.

 -- Matthias Klose <doko@ubuntu.com>  Thu, 13 Feb 2020 08:31:45 +0100

ledger (3.1.3-1ubuntu3) focal; urgency=medium

  * No change rebuild against new boost1.71 ABI

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Mon, 03 Feb 2020 20:41:13 +0000

ledger (3.1.3-1ubuntu2) focal; urgency=medium

  * Drop build dependency on python.

 -- Matthias Klose <doko@ubuntu.com>  Mon, 27 Jan 2020 01:18:50 +0100

ledger (3.1.3-1build2) focal; urgency=medium

  * No-change rebuild to build with python3.8.

 -- Matthias Klose <doko@ubuntu.com>  Sat, 25 Jan 2020 04:33:02 +0000

ledger (3.1.3-1build1) focal; urgency=medium

  * No-change rebuild to generate dependencies on python2.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 17 Dec 2019 12:52:14 +0000

ledger (3.1.3-1) unstable; urgency=medium

  [ David Bremner ]
  * New upstream release
  * Don't build ledger-dbg (rely on auto generated -dbgsym package).

  [ Dimitri John Ledkov ]
  * Finish dh'ification
  * Drop python-ledger module, in preparation for python3
    transition. Closes: #945840
  * Drop obsolete inline patches for lisp (no longer exists), docs (using
    separate build-dir anyway) and rpath (just shipping the shared library
    globally now)
  * Fixup shipping private library, privately without headers & dev
    symlink.

 -- Dimitri John Ledkov <xnox@ubuntu.com>  Thu, 12 Dec 2019 14:17:21 +0000

ledger (3.1.2+dfsg1-2) unstable; urgency=medium

  * Drop build-depends on dh_elpa, no longer needed.

 -- David Bremner <bremner@debian.org>  Wed, 06 Feb 2019 08:14:26 -0400

=== debian/control ===
Source: ledger
Section: utils
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: David Bremner <bremner@debian.org>
Uploaders: Matt Palmer <mpalmer@debian.org>
Build-Depends: debhelper-compat (= 12), cmake, libgmp3-dev, libpcre3-dev,
	libexpat1-dev, libofx-dev, libmpfr-dev, libboost-regex1.67-dev,
	libboost-date-time1.67-dev, libboost-filesystem1.67-dev,
	libboost-iostreams1.67-dev, libboost-serialization1.67-dev,
	libboost-test1.67-dev, man2html-base, python3-dev, texinfo, texlive,
	libutfcpp-dev, libboost-python1.67-dev, dh-python
Standards-Version: 4.4.1
Homepage: http://ledger-cli.org
Vcs-Git: https://salsa.debian.org/debian/ledger.git
Vcs-Browser: https://salsa.debian.org/debian/ledger

Package: ledger
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Suggests: elpa-ledger,
#python3-ledger
Description: command-line double-entry accounting program
 Ledger is a powerful and flexible double-entry accounting system run
 entirely from the command line.  Your accounts ledger is stored in one or
 more plain-text files with a very simple and readable format, and ledger
 does the hard work of balancing your books and reporting.

#Package: python3-ledger
#Architecture: any
#Section: python
#Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends}
#Description: command-line double-entry accounting program (python3 extension)
# Ledger is a powerful and flexible double-entry accounting system run
# entirely from the command line.  Your accounts ledger is stored in one or
# more plain-text files with a very simple and readable format, and ledger
# does the hard work of balancing your books and reporting.
# .
# This package provides the python3 module

=== debian/rules ===
#!/usr/bin/make -f
%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DCMAKE_INSTALL_LIBDIR=lib/ledger -DBUILD_DOCS=1 -DBUILD_WEB_DOCS=1 #-DUSE_PYTHON=ON

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_auto_install:
	# do not care about shipping convenience library
	# as a public one, it's for private eyes only
	dh_auto_install
	rm -rf debian/*/usr/include/
	rm -rf debian/*/usr/lib/ledger/libledger.so

override_dh_compress:
	dh_compress	-X.pdf
